
DROP TABLE IF EXISTS p20_pdm.t01_chatrecord;
CREATE TABLE IF NOT EXISTS p20_pdm.t01_chatrecord (
	 conference_id  text 
	, create_date  text 
	, start_date  text 
	, start_url  text 
	, referrer  text 
	, chat_dura  text 
	, queue_dura  text 
	, visitor_id  text 
	, visit_nick  text 
	, visitor_ip  text 
	, visitor_email  text 
	, operator_id  text 
	, group_id  text 
	, group_name  text 
	, rate  text 
	, last_rate_comment  text 
	, operator_1_nick  text 
	, operator_2_nick  text 
	, operator_3_nick  text 
	, operator_4_nick  text 
	, Etl_Batch_No  varchar(50) 
	, Etl_First_Dt  timestamp(0) 
	, Etl_Job  varchar(50) 
	, Etl_Proc_Dt  timestamp(0) 
	, Etl_Tx_Dt  timestamp(0) 
	, Src_Sysname  varchar(50) 
	, Src_Table  varchar(50) 
	,primary key( conference_id )
);

 COMMENT ON COLUMN p20_pdm.t01_chatrecord.conference_id IS 'conferenceId'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.create_date IS 'chat creation date Asia/Shanghai'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.start_date IS 'chat start date Asia/Shanghai'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.start_url IS 'chat start url'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.referrer IS 'referrer'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.chat_dura IS 'chat duration in seconds'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.queue_dura IS 'queue duration in seconds'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.visitor_id IS 'visitor livechat id'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.visit_nick IS 'visitor nick'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.visitor_ip IS 'visitor ip'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.visitor_email IS 'visitor email'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.operator_id IS 'last operator id'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.group_id IS 'group'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.group_name IS 'group name'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.rate IS 'rate'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.last_rate_comment IS 'last rate comment'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.operator_1_nick IS 'operator 1 nick'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.operator_2_nick IS 'operator 2 nick'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.operator_3_nick IS 'operator 3 nick'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.operator_4_nick IS 'operator 4 nick'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.Etl_Batch_No IS '作业批次号'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.Etl_First_Dt IS '最初入库时间'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.Etl_Job IS '作业名称'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.Etl_Proc_Dt IS '本次入库时间'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.Etl_Tx_Dt IS '作业运行时间'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.Src_Sysname IS '来源系统'; 
 COMMENT ON COLUMN p20_pdm.t01_chatrecord.Src_Table IS '来源表'; 

COMMENT ON TABLE p20_pdm.t01_chatrecord IS '聊天记录';